mod Maux

incl Mtex

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/1 Tex_f1_pp_triang
  Subsup(Id(0,'T',0),75,Arg(0),None)

appldisp/2 Tex_f2_ln_sub
  Prefix(70,2,Arg(0),Fenced(Op('[',0),Arg(1),Op(']',0)))

rem 
  \para \bf  Examples of unary numeric functions.  \end 

rem 
  \para \it  Factorial.  \end 

fun Fact 'Tex_f1_n_fact'
  Fact(0) = 1
  Fact(n+1) = (n+1)*Fact(n)

rem 
  \para \it  Triangular numbers.  \end 

fun Triang 'Tex_f1_pp_triang'
  Triang(n) = n*(n+1)/2

rem 
  \para \it  Fibonacci numbers.  \end 

fun Fib 'Tex_f1_n_fib'
  Fib(0) = 0
  Fib(1) = 1
  Fib(n+2) = Fib(n+1)+Fib(n)

rem 
  \para \bf  Examples of binary numeric functions.  \end 

rem 
  \para \it  Greatest common divisor.  \end 

fun/2 Gcd 'Tex_f2_n_gcd'
  Gcd(x,0) = x
  Gcd(x,y) = Gcd(y,x mod y) <- y != 0

rem 
  \para \it  Modified Catalan pairing function.  \end 

fun/2 Pair 'Tex_f2_pp_pair'
  Pair(x,y) = Triang(x+y)+x+1

rem 
  \para \bf  Lists.  \end 

fun L 
  L(0) = 0
  L(v,w) = L(w)+1

fun/2 Sub 'Tex_f2_ln_sub'
  Sub(x,0) = v <- x = v,w
  Sub(x,i+1) = Sub(w,i) <- x = v,w

pred Lln 
  Lln(0)
  Lln(ns,nss) <- Ln(ns) & Lln(nss)

